# -*- coding: utf-8 -*-
"""
Created on Sat Jun  8 21:53:39 2019

@author: XueYuan

提取pdf信息
"""

from pdfminer.pdfparser import PDFParser,PDFDocument
from pdfminer.pdfinterp import PDFResourceManager, PDFPageInterpreter
from pdfminer.converter import PDFPageAggregator
from pdfminer.layout import LTTextBoxHorizontal,LAParams

'''
使用pdfminer提取pdf文本信息
'''
file = open(r'E:/pdf信息提取/temp.pdf', 'rb')
praser = PDFParser(file)   # 创建pdf文件分析器
doc = PDFDocument()   # 创建pdf文档
# 链接分析器与文档
praser.set_document(doc)
doc.set_parser(praser)

doc.initialize()

rsrcmgr = PDFResourceManager()   # 创建pdf资源管理器
# 创建PDF设备对象
laparams = LAParams()
device = PDFPageAggregator(rsrcmgr, laparams=laparams)
interpreter = PDFPageInterpreter(rsrcmgr, device)   # 创建pdf解释器对象

for page in doc.get_pages(): # 获取page列表，进行循环
    interpreter.process_page(page)
    layout = device.get_result()   # LTPage对象
    for x in layout:
        if (isinstance(x, LTTextBoxHorizontal)):
            results = x.get_text()
            print(results)



'''
使用tabula提取pdf表格信息
'''

from tabula import wrapper

file = r"E:/pdf信息提取/table.pdf"
table = wrapper.read_pdf(file, encoding='gbk', pages='all')
print(table)

wrapper.convert_into(file, "E:/pdf信息提取/table1.csv", pages="all")
