*=========================
*使用putpdf命令生成pdf文件
*=========================
* 纯文本
clear all
cd "E:\pdf信息提取"
putpdf begin
putpdf paragraph
putpdf text ("爬虫俱乐部"), linebreak
putpdf text ("将爬虫进行到底")
putpdf save temp.pdf, replace

* 表格
clear all
cd "E:\pdf信息提取"
sysuse auto
keep in 1/10
keep make - headroom
putpdf begin
putpdf paragraph
putpdf table tbl = data("_all"), varnames
putpdf save table.pdf, replace


* 方法一、命令行工具xpdf

! pdftotext temp.pdf temp.txt


* 方法二、python解析


* 方法三、wordconvert命令
*===============
*pdf文本内容提取
*===============
* 使用wordconvert将pdf文件转换成html，并提取信息
clear
wordconvert temp.pdf temp.html, replace encoding("gb18030")
set obs 1
gen v = fileread("temp.html")
replace v = ustrfrom(v, "gb18030", 1)
replace v = ustrregexra(v, "\r|\n", "")
replace v = ustrregexra(v, "<style>.*?</style>", "")
replace v = ustrregexra(v, "<.*?>", "")
compress


*===============
*pdf表格内容提取
*===============
wordconvert table.pdf table.html, replace encoding(gb18030)
infix strL v 1-100000 using table.html, clear
replace v = ustrfrom(v, "gb18030", 1)
forvalues i = `=_N'(-1)2 {
	if strpos(v[`i'], "</td>") & !strpos(v[`i'], "<td") {
		replace v = v + v[`i'] in `=`i'-1'
		drop in `i'
	}
}
keep if strpos(v, "</td>")
replace v = ustrregexra(v, "<.*?>", "")
forvalues i = 1/4 {
	gen v`i' = v[_n + `i']
}
keep if mod(_n, 5) == 1
nrow 1
destring _all, replace ignore(",")
compress

*============================
*长江电力年报摘要提取文本信息
*============================
clear
copy "http://www.sse.com.cn/disclosure/listedinfo/announcement/c/2019-04-30/600900_2018_nzy.pdf" 长江电力2018年报摘要.pdf, replace
wordconvert 长江电力2018年报摘要.pdf 长江电力2018年报摘要.html, replace encoding("gb18030")
set obs 1
gen v = fileread("长江电力2018年报摘要.html")
replace v = ustrfrom(v, "gb18030", 1)
replace v = ustrregexra(v, "\r|\n", "")
replace v = ustrregexra(v, "<style>.*?</style>", "")   //删除style部分
replace v = ustrregexra(v, "<p class=footnotedescription>.*?</p>", "")   //删除脚注
replace v = ustrregexra(v, "<table.*?</table>", "")   //删除表格
replace v = ustrregexra(v, "<.*?>", "")   //删除html标签
replace v = subinstr(v, "&nbsp;", "", .)

